/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model.tables;


import be.lghs.accounting.model.Accounting;
import be.lghs.accounting.model.Keys;
import be.lghs.accounting.model.tables.records.MovementsRecord;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;

import javax.annotation.processing.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row10;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Movements extends TableImpl<MovementsRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>accounting.movements</code>
     */
    public static final Movements MOVEMENTS = new Movements();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<MovementsRecord> getRecordType() {
        return MovementsRecord.class;
    }

    /**
     * The column <code>accounting.movements.id</code>.
     */
    public final TableField<MovementsRecord, UUID> ID = createField(DSL.name("id"), SQLDataType.UUID.nullable(false).defaultValue(DSL.field("uuid_generate_v4()", SQLDataType.UUID)), this, "");

    /**
     * The column <code>accounting.movements.amount</code>.
     */
    public final TableField<MovementsRecord, BigDecimal> AMOUNT = createField(DSL.name("amount"), SQLDataType.NUMERIC(10, 2).nullable(false), this, "");

    /**
     * The column <code>accounting.movements.entry_date</code>.
     */
    public final TableField<MovementsRecord, LocalDate> ENTRY_DATE = createField(DSL.name("entry_date"), SQLDataType.LOCALDATE.nullable(false), this, "");

    /**
     * The column <code>accounting.movements.account_id</code>.
     */
    public final TableField<MovementsRecord, UUID> ACCOUNT_ID = createField(DSL.name("account_id"), SQLDataType.UUID.nullable(false), this, "");

    /**
     * The column <code>accounting.movements.coda_id</code>.
     */
    public final TableField<MovementsRecord, UUID> CODA_ID = createField(DSL.name("coda_id"), SQLDataType.UUID, this, "");

    /**
     * The column <code>accounting.movements.coda_sequence_number</code>.
     */
    public final TableField<MovementsRecord, Integer> CODA_SEQUENCE_NUMBER = createField(DSL.name("coda_sequence_number"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>accounting.movements.counter_party_account_number</code>.
     */
    public final TableField<MovementsRecord, String> COUNTER_PARTY_ACCOUNT_NUMBER = createField(DSL.name("counter_party_account_number"), SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>accounting.movements.counter_party_name</code>.
     */
    public final TableField<MovementsRecord, String> COUNTER_PARTY_NAME = createField(DSL.name("counter_party_name"), SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>accounting.movements.communication</code>.
     */
    public final TableField<MovementsRecord, String> COMMUNICATION = createField(DSL.name("communication"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>accounting.movements.category_id</code>.
     */
    public final TableField<MovementsRecord, UUID> CATEGORY_ID = createField(DSL.name("category_id"), SQLDataType.UUID, this, "");

    private Movements(Name alias, Table<MovementsRecord> aliased) {
        this(alias, aliased, null);
    }

    private Movements(Name alias, Table<MovementsRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>accounting.movements</code> table reference
     */
    public Movements(String alias) {
        this(DSL.name(alias), MOVEMENTS);
    }

    /**
     * Create an aliased <code>accounting.movements</code> table reference
     */
    public Movements(Name alias) {
        this(alias, MOVEMENTS);
    }

    /**
     * Create a <code>accounting.movements</code> table reference
     */
    public Movements() {
        this(DSL.name("movements"), null);
    }

    public <O extends Record> Movements(Table<O> child, ForeignKey<O, MovementsRecord> key) {
        super(child, key, MOVEMENTS);
    }

    @Override
    public Schema getSchema() {
        return Accounting.ACCOUNTING;
    }

    @Override
    public UniqueKey<MovementsRecord> getPrimaryKey() {
        return Keys.MOVEMENTS_PKEY;
    }

    @Override
    public List<UniqueKey<MovementsRecord>> getKeys() {
        return Arrays.<UniqueKey<MovementsRecord>>asList(Keys.MOVEMENTS_PKEY);
    }

    @Override
    public List<ForeignKey<MovementsRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<MovementsRecord, ?>>asList(Keys.MOVEMENTS__MOVEMENTS_ACCOUNT_ID_FKEY, Keys.MOVEMENTS__MOVEMENTS_CODA_ID_FKEY, Keys.MOVEMENTS__MOVEMENTS_CATEGORY_ID_FKEY);
    }

    private transient Accounts _accounts;
    private transient Codas _codas;
    private transient MovementCategories _movementCategories;

    public Accounts accounts() {
        if (_accounts == null)
            _accounts = new Accounts(this, Keys.MOVEMENTS__MOVEMENTS_ACCOUNT_ID_FKEY);

        return _accounts;
    }

    public Codas codas() {
        if (_codas == null)
            _codas = new Codas(this, Keys.MOVEMENTS__MOVEMENTS_CODA_ID_FKEY);

        return _codas;
    }

    public MovementCategories movementCategories() {
        if (_movementCategories == null)
            _movementCategories = new MovementCategories(this, Keys.MOVEMENTS__MOVEMENTS_CATEGORY_ID_FKEY);

        return _movementCategories;
    }

    @Override
    public Movements as(String alias) {
        return new Movements(DSL.name(alias), this);
    }

    @Override
    public Movements as(Name alias) {
        return new Movements(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Movements rename(String name) {
        return new Movements(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Movements rename(Name name) {
        return new Movements(name, null);
    }

    // -------------------------------------------------------------------------
    // Row10 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row10<UUID, BigDecimal, LocalDate, UUID, UUID, Integer, String, String, String, UUID> fieldsRow() {
        return (Row10) super.fieldsRow();
    }
}
